% Copyright 2007 Noah B. Jacobsen.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU Lesser General Public License as
% published by the Free Software Foundation, either version 3 of the
% License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% Lesser General Public License for more details.
% 
% You should have received a copy of the GNU Lesser General Public
% License along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
%pchk = '../codes/ExtTriang1.pchk';
%pchk = '../codes/peg20_dc5_max25_1504_triang.pchk';
pchk = '../../ldpc/codes/mitsu_1504.pchk';
H = import_pchk(pchk);

int_v = hist(sum(H,1),[1:100]);
dv = find(int_v>0);
int_v = int_v(dv);
pv_n = int_v/sum(int_v);
pv = int_v.*dv/sum(int_v.*dv);

int_c = hist(sum(H,2),[1:100]);
dc = find(int_c>0);
int_c = int_c(dc);
pc_n = int_c/sum(int_c);
pc = int_c.*dc/sum(int_c.*dc);

% $$$ R = 1-m/n;
% $$$ R = 1/3;
% $$$ snr_dB = .2;
% $$$ s_ch = 10^(snr_dB/10)*R;
% $$$ load J
% $$$ Ich = interp1(s,J,s_ch);

%Ich = .85;
%Ich = .7;
%Ich = .524;
%Ich = .355;
Ich = .29;

xx = [0:.001:1];
A = get_var_fn(dv,Ich,xx);
B = get_chk_fn(dc,xx);

figure
plot(xx,pv*A,'b-',xx,pc*B,'g--')
axis([0 1 0 1])
grid