% Copyright 2007 Noah B. Jacobsen.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU Lesser General Public License as
% published by the Free Software Foundation, either version 3 of the
% License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% Lesser General Public License for more details.
% 
% You should have received a copy of the GNU Lesser General Public
% License along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
clear
close all

s1 = [.001 .07 .15 .23 .32 .415 .52 .635 .755 .895 1.045 1.21 1.405 ...
     1.62 1.855 2.18 2.55 3.05 3.75 5 7 20];
N = 4e5;
    
J1 = zeros(1,length(s1));
for a = 1:10
  for l = 1:length(s1)
    u = rand(1,N)>.5;
    u_mod = (-1).^u;
    lu = 2*s1(l)*u_mod + 2*sqrt(s1(l))*randn(1,N);
    
    JJ = mutual(lu,u,200);
    J1(l) = (a-1)*J1(l)/a + JJ/a;
  end
end

%plot(J1,s1,'b-')
%hold on

dJ = .02;
ddJ = .001;
J0 = [[dJ:dJ:1-dJ],[1-dJ+ddJ:ddJ:1-ddJ],[1-3*ddJ/4:ddJ/4:1-ddJ/4]];
L = length(J0);

STY = {'k.','r.','go'};
A = [10 20 100];
%A = [1 2 5];
T = length(A);

for t = 1:T
  s = interp1(J1,s1,J0);
  J = zeros(1,L);

  for l = 1:L
    for a = 1:A(t)
      u = rand(1,N)>.5;
      u_mod = (-1).^u;
      lu = 2*s(l)*u_mod + 2*sqrt(s(l))*randn(1,N);

      %JJ = 1-mean(log2(1+exp(-u_mod.*lu)));
      JJ = mutual(lu,u,200);
      J(l) = (a-1)*J(l)/a + JJ/a;
    end
  end
  
  %plot(J,s,STY{t})
  s1 = [0,s,s(end)+5];
  J1 = [0,J,1.000001];
end

%plot(ones(2,1)*J0,[30;0]*ones(1,L),'k:')
save J J1 s1 J s