% Copyright 2007 Noah B. Jacobsen.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU Lesser General Public License as
% published by the Free Software Foundation, either version 3 of the
% License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% Lesser General Public License for more details.
% 
% You should have received a copy of the GNU Lesser General Public
% License along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
function [dv,pv,dc,pc] = match_var0(R,dv,dc,pc_n,xx,tol,EPS,filename,N,p1_n)
Nv = length(dv);

I_ch = R + tol;
I_v = get_var_fn(dv,I_ch,xx);

pc = pc_n.*dc/sum(pc_n.*dc);
n1 = sum(pc./dc)/(1-R);

I_c = get_chk_fn(dc,xx);
I_c = pc*I_c;

% $$$ R = 1-((1./dc)*pc')/((1./dv)*pv')
%Ceq = [ones(1,Nv); 1./dv; [1/n1 zeros(1,Nv-1)]];
%deq = [1; (1./dc)*pc'/(1-R); p1_n];
Ceq = [ones(1,Nv); 1./dv];
deq = [1; (1./dc)*pc'/(1-R)];
 
lb = [zeros(Nv,1)];
%ub = [1;2*((1./dc)*pc');ones(Nv-2,1)];%% #2s < M
ub = ones(Nv,1);

options = optimset('lsqlin');
options = optimset(options,'MaxIter',500);
options = optimset(options,'Display','Iter');

pv = lsqlin(I_v',I_c',-I_v',-I_c',Ceq,deq,lb,ub,[],options);
%snorm = @(x) -abs(x'*I_v(:,find(xx==.15)) - I_c(find(xx==.15))).^2;
%pv = fmincon(snorm,pv,-I_v',-I_c',Ceq,deq,lb,ub);

figure
plot(xx,I_c,'b-',xx,pv'*I_v,'g--')
axis([0 1 0 1]) 
hold on

pv_n = pv'./dv/sum(pv'./dv);
dv = dv(find(pv_n>EPS));
pv_n = pv_n(find(pv_n>EPS));

pv_n = pv_n/sum(pv_n);
pv = pv_n.*dv/sum(pv_n.*dv);
testrc;

if(p1_n>0)
  p1 = [p1_n pv_n(1)-p1_n pv_n(2:end)];
  d1 = [1 dv];
else
  p1 = pv_n;
  d1 = dv;
end

outfile = fopen(filename,'w');
fprintf(outfile,'%d\n\n',N);

fprintf(outfile,'%1.5e\n%d\n',R,length(dc));
for n=1:length(dc),fprintf(outfile,'%d ',dc(n));end;
fprintf(outfile,'\n');
for n=1:length(dc),fprintf(outfile,'%1.7e ',pc_n(n));end;
fprintf(outfile,'\n%d\n',length(d1));
for n=1:length(d1),fprintf(outfile,'%d ',d1(n));end;
fprintf(outfile,'\n');
for n=1:length(d1),fprintf(outfile,'%1.7e ',p1(n));end;
fprintf(outfile,'\n\n');
fclose(outfile);
