% Copyright 2007 Noah B. Jacobsen.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU Lesser General Public License as
% published by the Free Software Foundation, either version 3 of the
% License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% Lesser General Public License for more details.
% 
% You should have received a copy of the GNU Lesser General Public
% License along with this program.  If not, see <http://www.gnu.org/licenses/>.
%

close all
load J

figure
plot(10*log10(s),J,'k-')
hold on

R = [4/5 2/3 1/2 1/3 1/5];
dR = 10*log10(R) + 3;

plot([3.52  2.66  1.854  1.2355  1.06]+dR,R,'k:s')
plot([3.0675  2.2  1.3377  .8337  .6008]+dR,R,'k:o')
plot([2.6606 1.7695 .9605 .4492 .25 ]+dR,R,'k:^')


axis([-8 3 .18 .82])
xlabel('E_s/N_0 (dB)')
ylabel('Rate')
legend('AWGN capacity','k=600','k=1500','k=6000')
grid on