% Copyright 2007 Noah B. Jacobsen.
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU Lesser General Public License as
% published by the Free Software Foundation, either version 3 of the
% License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% Lesser General Public License for more details.
% 
% You should have received a copy of the GNU Lesser General Public
% License along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
clear
close all
warning off all

%filename = '../codes/Profiles/rc5.deg';
filename = '../codes/3gpp_pf9/pf9.deg';

xx = [0:.001:1];
EPS = 1e-6;

XX = []; YY = [];
save testrc XX YY

R = [.6400 .3200 .2133 .1600 .1280];
%R = [4/5  2/3  1/2  1/3  1/5];
dv_max = [30 30 30 30 30];
%%% ldpcopt check-degrees
dc_de = [14 6 5.5 4.9 4.3];

N = length(R);
N = 5;
%Fraction of new check nodes relative to the extending code
npr = (1-R(2:end)./R(1:end-1))./(1-R(2:end));

%%Base-code check degree distribution
dc = [10 11 ];
pc_n = [.5 .5];

%Relative to the extending code:
%Average degree of new edge growth check nodes
d_eg = [5.5  4.9  6.2  3.3 ];
%Fraction of new edge growth check nodes
p_eg = [.14  .2  .26  .22 ].*npr;

tol = [.011  .013  .01  .013  .01 ];
%%Force degree-1 variables
p1_n = [.01  .08  .08  .09  .09 ];

%%Base-code optimization
dv1 = [1:dv_max(1)];
[dv,pv,dc,pc]=match_var0(R(1),dv1,dc,pc_n,xx,tol(1),EPS,filename,N,p1_n(1));

pc_n = pc./dc/sum(pc./dc);
dc_ave = dc*pc_n';
dc_var = abs(dc-dc_ave).^2 *pc_n' /(abs(dc).^2 *pc_n');

%%Extending codes optimizations
cs2 = 0;
for n = 2:N
  dv1 = [1:dv_max(n)];
  [dv,pv,dc,pc,cs2]=match_var(R(n),dv1,p_eg(n-1),d_eg(n-1),R(n-1),dv,pv,dc,pc,xx,tol(n),EPS,filename,p1_n(n),cs2);

  pc_n = pc./dc/sum(pc./dc);
  dc_ave(n) = dc*pc_n';
  dc_var(n) = abs(dc-dc_ave(n)).^2 *pc_n' /(abs(dc).^2 *pc_n');
end

dc_de
dc_ave
dc_var

load testrc
figure
plot(XX,YY)
axis([0 40 0 1.0001])

%close all