/* Copyright 2007 Noah B. Jacobsen.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/************************************************************************/
/*        *******Includes code from:*********                           */
/*        Free software: Progressive edge-growth (PEG) algorithm        */
/*        Created by Xiaoyu Hu                                          */
/*                   Evangelos Eletheriou                               */
/*                   Dieter Arnold                                      */
/*        IBM Research, Zurich Research Lab., Switzerland               */
/**********************************************************************/
#ifndef BIGTRIANG
#define BIGTRIANG

#include <stdlib.h>
#include <iostream.h> // C++ I/O library header
#include "NodesInGraph.h"
#include "Random.h"
#define EPS 1e-6

class BigTriang {
 public:
  int M, N;
  int K;
  int EXPAND_DEPTH;
  char *filename;
  int *(*H);
  int *localGirth;  
  NodesInGraph *nodesInGraph;

  BigTriang(int m, int n, int *symbolDegSequence, char *filename, Random *rand, int & numDeg, int *deg, double *degFrac);
  BigTriang(void);

  void loadH(void);
  void writeToFile(void);
  
  ~BigTriang(void);

 private:
  int selectConstrainedParityConnect(int kthSymbol, int mthConnection, int & cycle, int startNewParity, Random *rand, int sglConcent);

  void updateConnection(int kthSymbol);
  void intio_write(FILE *f, int v);
};

#endif


