/************************************************************************/
/*                                                                      */
/*        Free software: Progressive edge-growth (PEG) algorithm        */
/*        Created by Xiaoyu Hu                                          */
/*                   Evangelos Eletheriou                               */
/*                   Dieter Arnold                                      */
/*        IBM Research, Zurich Research Lab., Switzerland               */
/*                                                                      */
/*        The C++ sources files have been compiled using xlC compiler   */
/*        at IBM RS/6000 running AIX. For other compilers and platforms,*/
/*        minor changes might be needed.                                */
/*                                                                      */
/*        Bug reporting to: xhu@zurich.ibm.com                          */
/**********************************************************************/
#ifndef CYCLESOFGRAPG
#define CYCLESOFGRAPG

#include <stdlib.h>
#include <iostream.h> // C++ I/O library header
//#include <iomanip.h>

class NodesOfGraph{
 public:
  int numOfParityConnections;
  int *parityConnections;
  int numOfSymbolConnections;
  int *symbolConnections;
  int numOfSymbolMapping;
  int *symbolMapping;
  NodesOfGraph(void);
  ~NodesOfGraph(void);
  void setParityConnections(int num, int *value);
  void setSymbolConnections(int num, int *value);
  void setSymbolMapping(int num, int *values);
}; //Why this is necessary?

class CyclesOfGraph {
 public:
  int M, N;
  int *(*H);
  int *cyclesTable;
  NodesOfGraph *nodesOfGraph;
  CyclesOfGraph(int mm, int n, int *(*h));
  ~CyclesOfGraph(void);
  void getCyclesTable(void);
  void printCyclesTable(void);
  int girth(void);
 private:
  int *tmp, *med, *tmpCycles;
};

#endif


