/* Copyright 2007 Noah B. Jacobsen.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef EXTTRIANG
#define EXTTRIANG

#include <stdlib.h>
#include <iostream.h> // C++ I/O library header
#include <math.h>
#include "BigTriang.h"
#include "NodesInGraph.h"
#include "Random.h"

class ExtTriang{
 public:
  int M, N;
  char *filename;
  int *localGirth;
  NodesInGraph *nodesInGraph;

  ExtTriang(int m, int n, int *symbolDegSequence, int numSplitParity, char *filename, BigTriang *baseGraph, Random *rand);

  ExtTriang(void);
  ~ExtTriang(void);

 private:
  void splitParityPeg(int numNewParity, int numSplitParity, Random *rand);
  void splitParityRand(int numNewParity, int numSplitParity, Random *rand);
  void mvBaseGraph(BigTriang *baseGraph, int & numNewParity);
  void mvExtGraph(BigTriang *baseGraph);
  void splitSymbol(int mvSymbol, int origParity, int newParity);
  void unsplitSymbol(int mvSymbol, int origParity, int newParity);

  int selectConstrainedParityConnect(int kthSymbol, int mthConnection, int & cycle, int startNewParity, Random *rand);
  void updateConnection(int kthSymbol);
};

#endif









