/* Copyright 2007 Noah B. Jacobsen.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/************************************************************************/
/*        *******Includes code from:*********                           */
/*        Free software: Progressive edge-growth (PEG) algorithm        */
/*        Created by Xiaoyu Hu                                          */
/*                   Evangelos Eletheriou                               */
/*                   Dieter Arnold                                      */
/*        IBM Research, Zurich Research Lab., Switzerland               */
/**********************************************************************/
#include <stdlib.h>
#include <iostream.h>
#include "NodesInGraph.h"

NodesInGraph::NodesInGraph(void) {;}

void NodesInGraph::setNumOfConnectionSymbolBit(int deg) {
  if(deg<0) {cout<<"Wrong NodesInGraph::setNumOfConnectionSymbolBit()"<<endl;exit(-1);}
  numOfConnectionSymbolBit=deg;
  numOfAssignedSymbolBit=0;
  keepAsDegreeTwo=0;
  connectionSymbolBit=new int[100];
  connectionParityBit=NULL;
}

void NodesInGraph::initConnectionParityBit(void) {
  maxDegParity=10000;
  numOfConnectionParityBit=0;
  connectionParityBit=new int[100];
}

void NodesInGraph::initConnectionParityBit(int deg) {
  maxDegParity=deg;
  numOfConnectionParityBit=0;
  connectionParityBit=new int[100];
}

NodesInGraph::~NodesInGraph(void) {
  if(connectionParityBit!=NULL)
    delete [] connectionParityBit;
  if(connectionSymbolBit!=NULL)
    delete [] connectionSymbolBit;
}
